import React from 'react';
import { useCollectionDataSource } from '@nocobase/client';
import { FilterDynamicComponent } from '../components/FilterDynamicComponent';
import { Instruction } from '.';
declare function IndividualHooksRadioWithTooltip({ onChange, ...props }: {
    [x: string]: any;
    onChange: any;
}): React.JSX.Element;
export default class extends Instruction {
    title: string;
    type: string;
    group: string;
    description: string;
    fieldset: {
        collection: {
            type: string;
            title: string;
            required: boolean;
            'x-reactions': any[];
            'x-decorator': string;
            'x-component': string;
            'x-component-props': {
                className: string;
            };
        };
        params: {
            type: string;
            properties: {
                individualHooks: {
                    type: string;
                    title: string;
                    'x-decorator': string;
                    'x-component': string;
                    'x-component-props': {
                        options: {
                            label: string;
                            value: boolean;
                            tooltip: string;
                        }[];
                    };
                    default: boolean;
                };
                filter: {
                    title: string;
                    "x-validator"(value: any): string;
                    type: string;
                    'x-decorator': string;
                    'x-component': string;
                    'x-component-props': {
                        useProps(): {
                            options: any[];
                            className: string;
                        };
                        dynamicComponent: string;
                    };
                };
                values: {
                    'x-component-props': {
                        filter(this: any, field: any): any;
                    };
                    type: string;
                    title: string;
                    'x-decorator': string;
                    'x-decorator-props': {
                        labelAlign: string;
                        className: string;
                    };
                    'x-component': string;
                    description: string;
                };
            };
        };
    };
    scope: {
        useCollectionDataSource: typeof useCollectionDataSource;
    };
    components: {
        FilterDynamicComponent: typeof FilterDynamicComponent;
        CollectionFieldset: React.MemoExoticComponent<import("@formily/react").ReactFC<Omit<any, "ref">>>;
        IndividualHooksRadioWithTooltip: typeof IndividualHooksRadioWithTooltip;
    };
}
export {};
